(*
     RadioChat Example Extension-API Library INCLUDE FILE

     Confidental property of Dirk Faust
     Use this as a macro for scripting your own RC-API-Extensions
*)

type TUCB=record      // ** User Control Block **
       active         :Boolean;                // Active entry?
       reserved1      :Integer;                // ..reserved for internal use..
       UID            :String[60];             // UserID
       UName          :String[40];             // Username
       UZeilen        :Integer;                // Rows (for screen)
       UZeilen_Made   :Integer;                // Rows processed
       UColor         :String[20];             // #nnnnnn HTML-User-Color
       URaum          :Integer;                // RoomID
       reserved2      :Integer;                // ..reserved for internal use..
       UStart         :TDateTime;              // Date+Time of last action
       UPhone         :Boolean;                // TRUE = Users wants to show Phone-symbol
       x_reserved0    :Integer;
       x_reserved1    :Integer;
       x_reserved2    :Integer;
       x_reserved3    :Integer;
       x_reserved4    :Integer;
       x_reserved5    :Integer;
       x_reserved6    :Integer;
       x_reserved7    :Integer;
       x_reserved8    :Integer;
       x_reserved9    :Integer;
     end;

type TRCB=record      // ** Room Control Block **
       active         :Boolean;                // Active entry?
       rname          :String[40];             // Roomname
       locked         :Boolean;                // Is locked by Superuser?
       reserved       :Integer;                // ..reserved for internal use..
       superUID       :String[60];             // UserID of Superuser
       LastLine       :Array[1..10] of String; // Last 10 Lines of "spoken" text
       // Note: since V.3.71, the history (lastline) can be choosen by the user.
       // In order, there may be only 1..10 lines used. Unused lines are even "" (NULL). 
     end;

var TCServerInstance:DWORD;
    RCWriteAll:Function(was:PChar):Boolean; stdcall;
    // Write to all clients in all rooms
    RCWriteUID:Function(UID, was:PChar):Boolean; stdcall;
    // Write to current client
    RCWriteRoom:Function(roomid:Integer; was:PChar):Boolean; stdcall;
    // Write to current client
    RCRoomInfo:Function(roomid:Integer):TRCB; stdcall;
    // Fill RCB with data of specified room
    RCUIDFromName:Function(uid:PChar; neuuid:PChar):Boolean; stdcall;
    // Get UID from a name

Procedure RCExtStart(ServerInstance:DWORD); cdecl far;
var temp:TFARPROC;
begin
(*  ShowMessage('Sample: '+IntToStr(ServerInstance));
  ShowMessage('Sample @: '+IntToStr(DWORD(@ServerInstance))); *)
  // ***** initialisation from RadioChat Server - DO NOT CHANGE! *****
  TCServerInstance:=ServerInstance;
  temp:=GetProcAddress(ServerInstance, PChar('RCWriteAll'));
  RCWriteAll:=temp;
  temp:=GetProcAddress(ServerInstance, PChar('RCWriteUID'));
  RCWriteUID:=temp;
  temp:=GetProcAddress(ServerInstance, PChar('RCWriteRoom'));
  RCWriteRoom:=temp;
  temp:=GetProcAddress(ServerInstance, PChar('RCRoomInfo'));
  RCRoomInfo:=temp;
  temp:=GetProcAddress(ServerInstance, PChar('RCUIDFromName'));
  RCUIDFromName:=temp;
end;


